//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Ms3FileRepairUnit.h"
#include "Ms3Recorder.h"
#include "BtnController.h"
#include "Log.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMs3FileRepair *frmMs3FileRepair;
//---------------------------------------------------------------------------
__fastcall TfrmMs3FileRepair::TfrmMs3FileRepair(TComponent* Owner)
	: TForm(Owner)
{
	fix_status.progress = 0;
	ProgressBar->Position = fix_status.progress;
}
//---------------------------------------------------------------------------

AnsiString TfrmMs3FileRepair::GetStatusDescription(enum TfrmMs3FileRepair::E_STATUS status)
{
	AnsiString msg;
	switch (status)
	{
	case	E_FIXED:
		msg = "Fixed file was created (check original file directory)";
		break;
	case	E_ERRORFIXING:
		msg = "Error occured during creting fixed file";
		break;
	case	E_ABORTED:
		msg = "Fixed file not created - user abort";
		break;
	case	E_NOTHINGTODO:
		msg = "File is not damaged - nothing to do";
		break;
	case	E_CANTFIX:
		msg = "Can not fix file";
		break;
	default:
		msg.sprintf("Error %d when trying to fix file. No detailed description.");
		break;
	}
	return msg;
}

__fastcall TfrmMs3FileRepair::ShowModal(void)
{
	return TForm::ShowModal();
}

enum TfrmMs3FileRepair::E_STATUS TfrmMs3FileRepair::Execute(AnsiString filename)
{
    fix_status.progress = 0;
	enum Ms3Recorder::ERR err = Ms3Recorder::VerifyFile(filename);
	if (err == Ms3Recorder::ERR_NONE)
		return E_NOTHINGTODO;
	if (err == Ms3Recorder::ERR_MISSING_FILE_FOOTER)
	{
        lblErrorTypeVal->Caption = "Missing file index and/or footer";
		fix_status.status = E_ABORTED;
		fix_status.filename = filename;
		ShowModal();
		return fix_status.status;
	}
	else
	{
		LOG(E_LOG_TRACE, "MS3 repair: can't fix file - file status = %d", err);
		return E_CANTFIX;
	}
}

void __fastcall TfrmMs3FileRepair::btnCloseClick(TObject *Sender)
{
	this->Close();	
}
//---------------------------------------------------------------------------

void __fastcall TfrmMs3FileRepair::btnCreateFixedFileClick(TObject *Sender)
{
    // lock buttons until done
	BtnController btnCtrlClose(btnClose);
	BtnController btnCtrlCreateFixed(btnCreateFixedFile);

	DWORD dwtid;
	HANDLE Thread = CreateThread(NULL, 0, ThreadRepairProc, &this->fix_status, 0, &dwtid);
	if (!Thread)
	{
		fix_status.status = E_ERRORFIXING;
		LOG(E_LOG_TRACE, "Ms3 file repair: failed to create thread");
		return;
	}
}
//---------------------------------------------------------------------------

DWORD WINAPI ThreadRepairProc(LPVOID data)
{
	TfrmMs3FileRepair::S_FIX_STATUS *status = (TfrmMs3FileRepair::S_FIX_STATUS*)data;
	AnsiString output = status->filename;
	output.Insert("_fixed", output.Length() - ExtractFileExt(output).Length() + 1);
	enum Ms3Recorder::ERR err =
		Ms3Recorder::FixMissingFileFooter(status->filename, output, frmMs3FileRepair->fix_status.progress);

	return 0;
}

void __fastcall TfrmMs3FileRepair::TimerTimer(TObject *Sender)
{
	if (!Visible)
		return;
	ProgressBar->Position = fix_status.progress;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMs3FileRepair::FormShow(TObject *Sender)
{
	fix_status.progress = 0;
	ProgressBar->Position = fix_status.progress;	
}
//---------------------------------------------------------------------------

